=== debian/changelog ===
fscrypt (0.2.2-0ubuntu2) bionic; urgency=medium

  * debian/copyright: Add copyright information for pam/constants.go

 -- Tyler Hicks <tyhicks@canonical.com>  Mon, 30 Oct 2017 14:43:14 +0000

fscrypt (0.2.2-0ubuntu1) bionic; urgency=medium

  * Initial release

 -- Tyler Hicks <tyhicks@canonical.com>  Fri, 27 Oct 2017 22:14:46 +0000
