=== debian/control ===
Source: fscrypt
Section: misc
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Uploaders: Tyler Hicks <tyhicks@canonical.com>
Build-Depends: debhelper (>= 10),
               dh-exec,
               dh-golang,
               golang-any,
               golang-github-pkg-errors-dev,
               golang-github-urfave-cli-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-sys-dev,
               golang-goprotobuf-dev,
               libargon2-0-dev (>= 0~20161029),
               libblkid-dev,
               libpam0g-dev,
Standards-Version: 4.1.0
Homepage: https://github.com/google/fscrypt
XS-Go-Import-Path: github.com/google/fscrypt
Testsuite: autopkgtest-pkg-go

Package: fscrypt
Architecture: linux-any
Built-Using: ${misc:Built-Using}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: e2fsprogs (>= 1.43~WIP.2015.05.18-1)
Description: Tool for managing Linux filesystem encryption
 fscrypt is a high-level tool for the management of Linux filesystem
 encryption. This tool manages metadata, key generation, key wrapping, PAM
 integration, and provides a uniform interface for creating and modifying
 encrypted directories.
 .
 To use fscrypt, you must have a filesystem with encryption enabled and a
 kernel that supports reading/writing from that filesystem. Currently, ext4,
 F2FS, and UBIFS support Linux filesystem encryption.

Package: libpam-fscrypt
Architecture: linux-any
Built-Using: ${misc:Built-Using}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         fscrypt
Description: PAM module for Linux filesystem encryption
 fscrypt is a high-level tool for the management of Linux filesystem
 encryption. This tool manages metadata, key generation, key wrapping, PAM
 integration, and provides a uniform interface for creating and modifying
 encrypted directories.
 .
 This PAM module can be used to unlock one or more directories upon user login
 and then lock those directories when the user ends their session.

Package: golang-github-google-fscrypt-dev
Architecture: linux-any
Depends: ${misc:Depends},
         golang-go,
         golang-github-pkg-errors-dev,
         golang-github-urfave-cli-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-sys-dev,
         golang-goprotobuf-dev,
Description: Linux filesystem encryption source code
 fscrypt is a high-level tool for the management of Linux filesystem
 encryption. This tool manages metadata, key generation, key wrapping, PAM
 integration, and provides a uniform interface for creating and modifying
 encrypted directories.
 .
 This package contains the source tree of the fscrypt project.
