=== debian/rules ===
#!/usr/bin/make -f

export GOPATH = $(CURDIR)/_build:/usr/share/gocode

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_auto_build:
	# use upstream's Makefile for building since pam_fscrypt.so needs to
	# build in c-shared mode but dh-golang doesn't support that mode
	$(MAKE)
