## fscrypt 0.2.5

=== Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 # the License.
 
 # Update on each new release!!
-VERSION := v0.2.4
+VERSION := v0.2.5
 NAME := fscrypt
 PAM_NAME := pam_$(NAME)
 
@@ -75,6 +75,7 @@
 ###### Find All Files and Directories ######
 FILES := $(shell find . \( -path ./vendor -o -path "./.*" \) -prune -o -type f -printf "%P\n")
 GO_FILES := $(filter %.go,$(FILES))
+GO_NONGEN_FILES := $(filter-out %.pb.go,$(GO_FILES))
 GO_DIRS := $(sort $(dir $(GO_FILES)))
 C_FILES := $(filter %.c %.h,$(FILES))
 PROTO_FILES := $(filter %.proto,$(FILES))
@@ -95,16 +96,17 @@
 	protoc --go_out=. $(PROTO_FILES)
 
 format: $(BIN)/goimports
-	goimports -w $(GO_DIRS)
+	goimports -w $(GO_NONGEN_FILES)
 	clang-format -i -style=Google $(C_FILES)
 
-lint: $(BIN)/golint $(BIN)/megacheck
+lint: $(BIN)/golint $(BIN)/staticcheck $(BIN)/misspell
 	go vet ./...
-	golint -set_exit_status ./...
-	megacheck -unused.exported -simple.exit-non-zero ./...
+	go list ./... | xargs -L1 golint -set_exit_status
+	staticcheck ./...
+	misspell -source=text $(FILES)
 
 clean:
-	rm -f $(BIN)/$(NAME) $(PAM_MODULE) $(TOOLS) coverage.out $(COVERAGE_FILES)
+	rm -f $(BIN)/$(NAME) $(PAM_MODULE) $(TOOLS) coverage.out $(COVERAGE_FILES) $(PAM_CONFIG)
 
 ###### Testing Commands (setup/teardown require sudo) ######
 .PHONY: test test-setup test-teardown
@@ -143,44 +145,57 @@
 .PHONY: install install-bin install-pam uninstall
 install: install-bin install-pam
 
-INSTALL := sudo install
-DESTDIR := /usr/local/bin
-PAM_MODULE_DIR := /lib/security
-PAM_CONFIG_DIR := /usr/share/pam-configs
+PREFIX := /usr/local
+DESTDIR := $(PREFIX)/bin
 
 install-bin: $(BIN)/$(NAME)
-	$(INSTALL) -d $(DESTDIR)
-	$(INSTALL) $< $(DESTDIR)
+	install -d $(DESTDIR)
+	install $< $(DESTDIR)
+
+PAM_MODULE_DIR := $(PREFIX)/lib/security
+PAM_INSTALL_PATH := $(PAM_MODULE_DIR)/$(PAM_NAME).so
+PAM_CONFIG := $(BIN)/config
+PAM_CONFIG_DIR := $(PREFIX)/share/pam-configs
 
 install-pam: $(PAM_MODULE)
-	$(INSTALL) -d $(PAM_MODULE_DIR)
-	$(INSTALL) $< $(PAM_MODULE_DIR)
-	$(INSTALL) -d $(PAM_CONFIG_DIR)
-	$(INSTALL) $(PAM_NAME)/config $(PAM_CONFIG_DIR)/$(NAME)
+	install -d $(PAM_MODULE_DIR)
+	install $(PAM_MODULE) $(PAM_MODULE_DIR)
+
+	m4 --define=PAM_INSTALL_PATH=$(PAM_INSTALL_PATH) < $(PAM_NAME)/config > $(PAM_CONFIG)
+	install -d $(PAM_CONFIG_DIR)
+	install $(PAM_CONFIG) $(PAM_CONFIG_DIR)/$(NAME)
 
 uninstall:
-	rm -f $(DESTDIR)/$(NAME) $(PAM_MODULE_DIR)/$(PAM_MODULE) $(PAM_CONFIG_DIR)/$(NAME)
+	rm -f $(DESTDIR)/$(NAME) $(PAM_INSTALL_PATH) $(PAM_CONFIG_DIR)/$(NAME)
 
 #### Tool Building Commands ####
-TOOLS := $(addprefix $(BIN)/,protoc golint protoc-gen-go goimports megacheck gocovmerge)
+TOOLS := $(addprefix $(BIN)/,protoc golint protoc-gen-go goimports staticcheck gocovmerge misspell)
 .PHONY: tools
 tools: $(TOOLS)
 
-# Go tools build from vendored sources
-VENDOR := $(shell find vendor -type f)
-$(BIN)/golint: $(VENDOR)
-	go build -o $@ ./vendor/github.com/golang/lint/golint
-$(BIN)/protoc-gen-go: $(VENDOR)
-	go build -o $@ ./vendor/github.com/golang/protobuf/protoc-gen-go
-$(BIN)/goimports: $(VENDOR)
-	go build -o $@ ./vendor/golang.org/x/tools/cmd/goimports
-$(BIN)/megacheck: $(VENDOR)
-	go build -o $@ ./vendor/honnef.co/go/tools/cmd/megacheck
-$(BIN)/gocovmerge: $(VENDOR)
-	go build -o $@ ./vendor/github.com/wadey/gocovmerge
+$(BIN)/golint:
+	GO111MODULE=off go get golang.org/x/lint/golint
+	GO111MODULE=off go build -o $@ golang.org/x/lint/golint
+$(BIN)/protoc-gen-go:
+	GO111MODULE=off go get -d github.com/golang/protobuf/protoc-gen-go
+	git -C "$(shell go env GOPATH)/src/github.com/golang/protobuf" checkout v1.2.0
+	go install github.com/golang/protobuf/protoc-gen-go
+	GO111MODULE=off go build -o $@ github.com/golang/protobuf/protoc-gen-go
+$(BIN)/goimports:
+	GO111MODULE=off go get golang.org/x/tools/cmd/goimports
+	GO111MODULE=off go build -o $@ golang.org/x/tools/cmd/goimports
+$(BIN)/staticcheck:
+	GO111MODULE=off go get honnef.co/go/tools/cmd/staticcheck
+	GO111MODULE=off go build -o $@ honnef.co/go/tools/cmd/staticcheck
+$(BIN)/gocovmerge:
+	GO111MODULE=off go get github.com/wadey/gocovmerge
+	GO111MODULE=off go build -o $@ github.com/wadey/gocovmerge
+$(BIN)/misspell:
+	GO111MODULE=off go get github.com/client9/misspell
+	GO111MODULE=off go build -o $@ github.com/client9/misspell/cmd/misspell
 
 # Non-go tools downloaded from appropriate repository
-PROTOC_VERSION := 3.5.1
+PROTOC_VERSION := 3.6.1
 ARCH := $(shell uname -m)
 ifeq (x86_64,$(ARCH))
 PROTOC_ARCH := x86_64
