=== debian/changelog ===
fscrypt (0.2.5-2) unstable; urgency=medium

  * The upstream libpam config file is now a template; compile it.
    (Closes: #946155)
  * Build-Depend on m4.

 -- Paride Legovini <pl@ninthfloor.org>  Wed, 04 Dec 2019 13:57:04 +0000

fscrypt (0.2.5-1) unstable; urgency=medium

  * New upstream version 0.2.5 (Closes: #945398).
  * Build-Depend on debhelper-compat and drop d/compat.
  * Bump Standards-Version to 4.4.1 (no changes needed).
  * d/control: add Rules-Requires-Root: no.
  * d/rules: drop DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed.
    ld --as-needed is enabled by default on Debian development versions.

 -- Paride Legovini <pl@ninthfloor.org>  Sat, 30 Nov 2019 15:20:33 +0000
