=== debian/control ===
--- 
+++ 
@@ -3,22 +3,24 @@
 Priority: optional
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Paride Legovini <pl@ninthfloor.org>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 12),
                dh-exec,
                dh-golang (>= 1.35),
                golang-any (>= 2:1.10~),
                golang-github-pkg-errors-dev,
                golang-github-urfave-cli-dev,
-               golang-golang-x-crypto-dev (>= 1:0.0~git20181203.505ab14-1+deb10u1),
+               golang-golang-x-crypto-dev (>= 1:0.0~git20180322.88942b9),
                golang-golang-x-sys-dev,
                golang-goprotobuf-dev,
-               libpam0g-dev
-Standards-Version: 4.2.0
+               libpam0g-dev,
+               m4
+Standards-Version: 4.4.1
 Homepage: https://github.com/google/fscrypt
 Vcs-Browser: https://salsa.debian.org/go-team/packages/fscrypt
 Vcs-Git: https://salsa.debian.org/go-team/packages/fscrypt.git
 XS-Go-Import-Path: github.com/google/fscrypt
 Testsuite: autopkgtest-pkg-go
+Rules-Requires-Root: no
 
 Package: fscrypt
 Architecture: linux-any
