=== debian/rules ===
--- 
+++ 
@@ -2,11 +2,8 @@
 
 include /usr/share/dpkg/pkg-info.mk
 
-export DH_VERBOSE = 1
-
 # https://wiki.debian.org/HardeningWalkthrough
-export DEB_BUILD_MAINT_OPTIONS  = hardening=+all
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 DH_GOPKG := github.com/google/fscrypt
 
@@ -41,7 +38,7 @@
 	# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=903385
 	#
 	# golang-go calls the library pam_fscrypt.a, while gccgo-go calls it libpam_fscrypt.a.
-	# One thing we (hopefully) now: there is only one .a file. Its path is also difficult
+	# One thing we (hopefully) know: there is only one .a file. Its path is also difficult
 	# to predict. Let's try to write a command that will always rename it to pam_fscrypt.so.
 	ls -l obj-*/pkg/*/$(DH_GOPKG)/*.a
 	SOPATH=$$(dirname obj-*/pkg/*/$(DH_GOPKG)/*.a) && mv -v $$SOPATH/*.a $$SOPATH/pam_fscrypt.so
@@ -57,3 +54,11 @@
 	# filesystem: requires a filesystem to test upon and root privileges
 
 	DH_GOLANG_EXCLUDES="crypto filesystem" dh_auto_test
+
+override_dh_install:
+	dh_install
+
+	# Adapted from the upstream Makefile
+	m4 --define=PAM_INSTALL_PATH=pam_fscrypt.so \
+		< pam_fscrypt/config \
+		> $(CURDIR)/debian/libpam-fscrypt/usr/share/pam-configs/fscrypt
