## fscrypt 0.2.9

=== Makefile ===
--- 
+++ 
@@ -16,16 +16,18 @@
 # the License.
 
 # Update on each new release!!
-VERSION := v0.2.5
+VERSION := v0.2.9
 NAME := fscrypt
 PAM_NAME := pam_$(NAME)
 
 ###### Makefile Command Line Flags ######
 #
-# BIN: The locaton where binaries will be built.    Default: ./bin
-# INSTALL: The tool used to install binaries.       Default: sudo install
-# DESTDIR: The location for the fscrypt binary.     Default: /usr/local/bin
-# PAM_MODULE_DIR: The location for pam_fscrypt.so.  Default: /lib/security
+# BIN: The location where binaries will be built.     Default: bin
+# DESTDIR: Installation destination directory.        Default: ""
+# PREFIX: Installation path prefix.                   Default: /usr/local
+# BINDIR: Where to install the fscrypt binary.        Default: $(PREFIX)/bin
+# PAM_MODULE_DIR: Where to install pam_fscrypt.so.    Default: $(PREFIX)/lib/security
+# PAM_CONFIG_DIR: Where to install Ubuntu PAM config. Default: $(PREFIX)/share/pam-configs
 #
 # MOUNT: The filesystem where our tests are run.    Default: /mnt/fscrypt_mount
 #   Ex: make test-setup MOUNT=/foo/bar
@@ -66,14 +68,18 @@
 # Flag to embed the version (pulled from tags) into the binary.
 TAG_VERSION := $(shell git describe --tags)
 VERSION_FLAG := -X "main.version=$(if $(TAG_VERSION),$(TAG_VERSION),$(VERSION))"
-# Flag to embed the date and time of the build into the binary.
-DATE_FLAG := -X "main.buildTime=$(shell date)"
-
-override GO_LINK_FLAGS += $(VERSION_FLAG) $(DATE_FLAG) -extldflags "$(LDFLAGS)"
+
+override GO_LINK_FLAGS += $(VERSION_FLAG) -extldflags "$(LDFLAGS)"
 override GO_FLAGS += --ldflags '$(GO_LINK_FLAGS)'
+# Always use Go modules
+export GO111MODULE = on
+# Use -trimpath if available
+ifneq "" "$(shell go help build | grep trimpath)"
+override GO_FLAGS += -trimpath
+endif
 
 ###### Find All Files and Directories ######
-FILES := $(shell find . \( -path ./vendor -o -path "./.*" \) -prune -o -type f -printf "%P\n")
+FILES := $(shell find . -path '*/.git*' -prune -o -type f -printf "%P\n")
 GO_FILES := $(filter %.go,$(FILES))
 GO_NONGEN_FILES := $(filter-out %.pb.go,$(GO_FILES))
 GO_DIRS := $(sort $(dir $(GO_FILES)))
@@ -104,11 +110,12 @@
 	go list ./... | xargs -L1 golint -set_exit_status
 	staticcheck ./...
 	misspell -source=text $(FILES)
+	( cd cli-tests && shellcheck -x *.sh)
 
 clean:
 	rm -f $(BIN)/$(NAME) $(PAM_MODULE) $(TOOLS) coverage.out $(COVERAGE_FILES) $(PAM_CONFIG)
 
-###### Testing Commands (setup/teardown require sudo) ######
+###### Go tests ######
 .PHONY: test test-setup test-teardown
 
 # If MOUNT exists signal that we should run integration tests.
@@ -133,6 +140,15 @@
 	rmdir $(MOUNT)
 	rm -f $(IMAGE)
 
+###### Command-line interface tests ######
+.PHONY: cli-test cli-test-update
+
+cli-test: $(BIN)/$(NAME)
+	sudo cli-tests/run.sh
+
+cli-test-update: $(BIN)/$(NAME)
+	sudo cli-tests/run.sh --update-output
+
 # Runs tests and generates coverage
 COVERAGE_FILES := $(addsuffix coverage.out,$(GO_DIRS))
 coverage.out: $(BIN)/gocovmerge $(COVERAGE_FILES)
@@ -146,11 +162,11 @@
 install: install-bin install-pam
 
 PREFIX := /usr/local
-DESTDIR := $(PREFIX)/bin
+BINDIR := $(PREFIX)/bin
 
 install-bin: $(BIN)/$(NAME)
-	install -d $(DESTDIR)
-	install $< $(DESTDIR)
+	install -d $(DESTDIR)$(BINDIR)
+	install $< $(DESTDIR)$(BINDIR)
 
 PAM_MODULE_DIR := $(PREFIX)/lib/security
 PAM_INSTALL_PATH := $(PAM_MODULE_DIR)/$(PAM_NAME).so
@@ -158,15 +174,17 @@
 PAM_CONFIG_DIR := $(PREFIX)/share/pam-configs
 
 install-pam: $(PAM_MODULE)
-	install -d $(PAM_MODULE_DIR)
-	install $(PAM_MODULE) $(PAM_MODULE_DIR)
+	install -d $(DESTDIR)$(PAM_MODULE_DIR)
+	install $(PAM_MODULE) $(DESTDIR)$(PAM_MODULE_DIR)
 
 	m4 --define=PAM_INSTALL_PATH=$(PAM_INSTALL_PATH) < $(PAM_NAME)/config > $(PAM_CONFIG)
-	install -d $(PAM_CONFIG_DIR)
-	install $(PAM_CONFIG) $(PAM_CONFIG_DIR)/$(NAME)
+	install -d $(DESTDIR)$(PAM_CONFIG_DIR)
+	install $(PAM_CONFIG) $(DESTDIR)$(PAM_CONFIG_DIR)/$(NAME)
 
 uninstall:
-	rm -f $(DESTDIR)/$(NAME) $(PAM_INSTALL_PATH) $(PAM_CONFIG_DIR)/$(NAME)
+	rm -f $(DESTDIR)$(BINDIR)/$(NAME) \
+	      $(DESTDIR)$(PAM_INSTALL_PATH) \
+	      $(DESTDIR)$(PAM_CONFIG_DIR)/$(NAME)
 
 #### Tool Building Commands ####
 TOOLS := $(addprefix $(BIN)/,protoc golint protoc-gen-go goimports staticcheck gocovmerge misspell)
@@ -174,25 +192,17 @@
 tools: $(TOOLS)
 
 $(BIN)/golint:
-	GO111MODULE=off go get golang.org/x/lint/golint
-	GO111MODULE=off go build -o $@ golang.org/x/lint/golint
+	go build -o $@ golang.org/x/lint/golint
 $(BIN)/protoc-gen-go:
-	GO111MODULE=off go get -d github.com/golang/protobuf/protoc-gen-go
-	git -C "$(shell go env GOPATH)/src/github.com/golang/protobuf" checkout v1.2.0
-	go install github.com/golang/protobuf/protoc-gen-go
-	GO111MODULE=off go build -o $@ github.com/golang/protobuf/protoc-gen-go
+	go build -o $@ github.com/golang/protobuf/protoc-gen-go
 $(BIN)/goimports:
-	GO111MODULE=off go get golang.org/x/tools/cmd/goimports
-	GO111MODULE=off go build -o $@ golang.org/x/tools/cmd/goimports
+	go build -o $@ golang.org/x/tools/cmd/goimports
 $(BIN)/staticcheck:
-	GO111MODULE=off go get honnef.co/go/tools/cmd/staticcheck
-	GO111MODULE=off go build -o $@ honnef.co/go/tools/cmd/staticcheck
+	go build -o $@ honnef.co/go/tools/cmd/staticcheck
 $(BIN)/gocovmerge:
-	GO111MODULE=off go get github.com/wadey/gocovmerge
-	GO111MODULE=off go build -o $@ github.com/wadey/gocovmerge
+	go build -o $@ github.com/wadey/gocovmerge
 $(BIN)/misspell:
-	GO111MODULE=off go get github.com/client9/misspell
-	GO111MODULE=off go build -o $@ github.com/client9/misspell/cmd/misspell
+	go build -o $@ github.com/client9/misspell/cmd/misspell
 
 # Non-go tools downloaded from appropriate repository
 PROTOC_VERSION := 3.6.1
