=== debian/changelog ===
fscrypt (0.2.9-1) unstable; urgency=medium

  * New upstream version 0.2.9.
  * Drop patch: 0001-cmd-fscrypt-fix-32-bit-build (upstreamed).

 -- Paride Legovini <paride@debian.org>  Mon, 15 Jun 2020 21:41:10 +0000

fscrypt (0.2.8-1) unstable; urgency=medium

  * New upstream version 0.2.8.
    - closes: #957239 (https://github.com/google/fscrypt/pull/224)
    - closes: #959531 (https://github.com/google/fscrypt/pull/221)
  * New patch: 0001-cmd-fscrypt-fix-32-bit-build.patch (cherry-pick)

 -- Paride Legovini <paride@debian.org>  Tue, 02 Jun 2020 23:00:54 +0000

fscrypt (0.2.7-1) unstable; urgency=medium

  * New upstream version 0.2.7 (closes: #959163).
  * d/rules: run dh_auto_install with --no-source.
  * d/rules: do not try to force -buildmode=pie.
  * d/control: bump the dh compat level to 13.
  * d/control: use the paride@debian.org alias in Uploaders.

 -- Paride Legovini <paride@debian.org>  Mon, 04 May 2020 13:06:29 +0000

fscrypt (0.2.6-1) unstable; urgency=medium

  * New upstream version 0.2.6 (closes: #952667).
  * d/copyright: drop the Files-Excluded section (not needed).
  * d/control: bump Standards-Version to 4.5.0 (no changes needed).
  * d/rules: the 'crypto' testsuite has been renamed to 'keyring'.

 -- Paride Legovini <pl@ninthfloor.org>  Wed, 04 Mar 2020 14:23:52 +0000
