=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: admin
 Priority: optional
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
-Uploaders: Paride Legovini <pl@ninthfloor.org>
-Build-Depends: debhelper-compat (= 12),
+Uploaders: Paride Legovini <paride@debian.org>
+Build-Depends: debhelper-compat (= 13),
                dh-exec,
                dh-golang (>= 1.35),
                golang-any (>= 2:1.10~),
@@ -14,7 +14,7 @@
                golang-goprotobuf-dev,
                libpam0g-dev,
                m4
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Homepage: https://github.com/google/fscrypt
 Vcs-Browser: https://salsa.debian.org/go-team/packages/fscrypt
 Vcs-Git: https://salsa.debian.org/go-team/packages/fscrypt.git
