=== debian/rules ===
--- 
+++ 
@@ -9,15 +9,6 @@
 
 ### Set some build flags.
 ### Partially borrowed from upstream Makefile
-
-# As of Go 1.11, -buildmode=pie not supported on linux/mips.
-#
-# REMINDER:
-# On new releases of Go check the release notes to see if we can get
-# rid of this exclusion. E.g. https://golang.org/doc/go1.11#compiler
-ifeq ($(filter $(DEB_HOST_ARCH),mips mipsel mips64el),)
-GO_FLAGS += -buildmode=pie
-endif
 
 GO_LINK_FLAGS := -s -w
 VERSION_FLAG := -X "main.version=v$(DEB_VERSION_UPSTREAM)"
@@ -43,17 +34,18 @@
 	ls -l obj-*/pkg/*/$(DH_GOPKG)/*.a
 	SOPATH=$$(dirname obj-*/pkg/*/$(DH_GOPKG)/*.a) && mv -v $$SOPATH/*.a $$SOPATH/pam_fscrypt.so
 
-	# Old workaround, for future reference:
-	#rename.ul -v .a .so obj-*/pkg/*/$(DH_GOPKG)/*.a
-
 override_dh_auto_test:
 	# Excluded tests:
 	#
-	# crypto:     needs a user keyring linked into the session keyring
+	# keyring:     needs a user keyring linked into the session keyring
 	#             https://github.com/google/fscrypt/issues/99
 	# filesystem: requires a filesystem to test upon and root privileges
 
-	DH_GOLANG_EXCLUDES="crypto filesystem" dh_auto_test
+	DH_GOLANG_EXCLUDES="keyring filesystem" dh_auto_test
+
+override_dh_auto_install:
+	# See dh-golang(3)
+	dh_auto_install -- --no-source
 
 override_dh_install:
 	dh_install
