=== debian/changelog ===
fscrypt (0.3.3-1) unstable; urgency=medium

  * New upstream version 0.3.1.
    Closes: #1006485, tracking:
     - CVE-2022-25326
     - CVE-2022-25327
     - CVE-2022-25328
  * d/gbp.conf: debian-branch = debian/latest (DEP-14)
  * d/copyright: update copyright years for debian/*

 -- Paride Legovini <paride@debian.org>  Mon, 07 Mar 2022 21:32:01 +0000

fscrypt (0.3.1-1) unstable; urgency=medium

  * New upstream version 0.3.1
  * d/copyright: update the maintainer email address (paride@debian.org)
  * d/control: bump Standards-Version to 4.6.0, no changes needed
  * debian/*: wrap-and-sort -bast (cosmetic)

 -- Paride Legovini <paride@debian.org>  Sun, 31 Oct 2021 17:09:10 +0000
