=== debian/control ===
Source: fscrypt
Section: admin
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Paride Legovini <paride@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-exec,
 dh-golang (>= 1.35),
 golang-any (>= 2:1.10~),
 golang-github-pkg-errors-dev,
 golang-github-urfave-cli-dev,
 golang-golang-x-crypto-dev (>= 1:0.0~git20180322.88942b9),
 golang-golang-x-sys-dev,
 golang-goprotobuf-dev,
 libpam0g-dev,
 m4,
Standards-Version: 4.6.0
Homepage: https://github.com/google/fscrypt
Vcs-Browser: https://salsa.debian.org/go-team/packages/fscrypt
Vcs-Git: https://salsa.debian.org/go-team/packages/fscrypt.git
XS-Go-Import-Path: github.com/google/fscrypt
Testsuite: autopkgtest-pkg-go
Rules-Requires-Root: no

Package: fscrypt
Architecture: linux-any
Built-Using:
 ${misc:Built-Using},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 libpam-fscrypt,
Description: Tool for managing Linux filesystem encryption
 fscrypt is a high-level tool for the management of Linux filesystem
 encryption. This tool manages metadata, key generation, key wrapping,
 PAM integration, and provides a uniform interface for creating and
 modifying encrypted directories.
 .
 To use fscrypt, you must have a filesystem with encryption enabled and
 a kernel that supports reading/writing from that filesystem. Currently,
 ext4, F2FS, and UBIFS support Linux filesystem encryption. Ext4 has
 supported Linux filesystem encryption since v4.1, F2FS added support
 in v4.2, and UBIFS added support in v4.10. Other filesystems may add
 support for native encryption in the future.

Package: libpam-fscrypt
Architecture: linux-any
Built-Using:
 ${misc:Built-Using},
Depends:
 fscrypt,
 ${misc:Depends},
 ${shlibs:Depends},
Description: PAM module for Linux filesystem encryption
 fscrypt is a high-level tool for the management of Linux filesystem
 encryption. This tool manages metadata, key generation, key wrapping,
 PAM integration, and provides a uniform interface for creating and
 modifying encrypted directories.
 .
 This PAM module can be used to unlock one or more directories upon user
 login and then lock those directories when the user ends their session.
