## fscrypt 0.3.4

=== debian/changelog ===
fscrypt (0.3.4-2) unstable; urgency=medium

  * d/libpam-fscrypt.install: install PAM modules into /usr.
    Thanks to Michael Biebl (Closes: 1061581)

 -- Paride Legovini <paride@debian.org>  Mon, 29 Jan 2024 12:10:15 +0100

fscrypt (0.3.4-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable)

  [ Paride Legovini ]
  * New upstream version 0.3.4. (Closes: #1060021)
  * d/control: replace golang-goprotobuf-dev with golang-google-protobuf-dev
  * d/control: bump Standards-Verstion to 4.6.2 (no changes needed)
  * d/copyright: update copyright years for debian/*
  * d/gbp.conf: revert to debian-branch = debian/sid.
    To better comply with the pkg-go team workflow.
  * d/changelog: fix typo in the 0.3.3-1 stanza
  * d/changelog: update my email address in past changelog entries

 -- Paride Legovini <paride@debian.org>  Mon, 08 Jan 2024 22:57:36 +0100
