=== debian/control ===
--- 
+++ 
@@ -7,16 +7,16 @@
 Build-Depends:
  debhelper-compat (= 13),
  dh-exec,
- dh-golang (>= 1.35),
- golang-any (>= 2:1.10~),
+ dh-golang,
+ golang-any,
  golang-github-pkg-errors-dev,
  golang-github-urfave-cli-dev,
- golang-golang-x-crypto-dev (>= 1:0.0~git20180322.88942b9),
+ golang-golang-x-crypto-dev,
  golang-golang-x-sys-dev,
- golang-goprotobuf-dev,
+ golang-google-protobuf-dev,
  libpam0g-dev,
  m4,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/google/fscrypt
 Vcs-Browser: https://salsa.debian.org/go-team/packages/fscrypt
 Vcs-Git: https://salsa.debian.org/go-team/packages/fscrypt.git
